# -*- coding: utf-8 -*-

# This is the panel in charge of replacing matches with text or operations.

"""
Copyright (C) 2006-2010 ianaré sévi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

ianare@gmail.com
"""

import wx
import opButtons
import search

[wxID_PANEL, wxID_PANELREPL_TXT, wxID_PANELSTATICTEXT1,
] = [wx.NewId() for initCtrls in range(3)]

class Panel(wx.Panel):
    def sizer(self):
        mainSizer = self.mainSizer = wx.BoxSizer(wx.VERTICAL)

        bottomSizer = wx.BoxSizer(wx.HORIZONTAL)
        bottomSizer.Add(self.staticText1,0,wx.ALIGN_CENTRE|wx.LEFT,5)
        bottomSizer.Add(self.repl_txt,1,wx.LEFT|wx.RIGHT,5)

        mainSizer.Add(self.search,0,wx.EXPAND|wx.LEFT|wx.RIGHT|wx.TOP,5)
        mainSizer.Add(bottomSizer,0,wx.EXPAND|wx.TOP,20)
        mainSizer.Add(self.opButtonsPanel,0,wx.EXPAND|wx.TOP|wx.BOTTOM,2)
        self.SetSizerAndFit(mainSizer)

    def initCtrls(self, prnt):
        wx.Panel.__init__(self, id=wxID_PANEL, name=u'ReplaceToolsPanel', parent=prnt,
              style=wx.TAB_TRAVERSAL)

        # sub operation buttons ------------------------------------------- #
        self.opButtonsPanel = opButtons.Panel(self, main)

        self.search = search.Panel(self, main, _(u"Search for what to replace, by:"))

        txt = _(u"Replace with (blank to delete):")
        self.staticText1 = wx.StaticText(id=wxID_PANELSTATICTEXT1,
              label=txt, name='staticText1',
              parent=self, style=0)
        Size = wx.Size(self.staticText1.GetTextExtent(txt)[0] + 3,-1)
        self.staticText1.SetMinSize(Size)

        self.repl_txt = wx.TextCtrl(id=wxID_PANELREPL_TXT,
              name=u'repl_txt', parent=self,
              style=wx.TE_PROCESS_ENTER, value=u'')
        self.repl_txt.SetToolTipString(_(u"Keep blank to delete."))
        self.repl_txt.Bind(wx.EVT_TEXT, main.showPreview)
        self.repl_txt.Bind(wx.EVT_TEXT_ENTER, main.showPreview)

    def __init__(self, parent, main_window, params={}):
        global main
        main = main_window
        self.initCtrls(parent)
        self.sizer()
        self.onLoad()

    def onLoad(self):
        self.activatedField = self.repl_txt
        self.search.onLoad(0)